#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "psql_conn.h"
#include "support.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <libsmtp.h>

static gint context_id = 0;
gint fila_seleccionada=-1;
gint ultima_pos=0;

void statusbar_message(gpointer message)
{
        gint count;

        context_id = gtk_statusbar_get_context_id(GTK_STATUSBAR(statusbar1), "Gtk-Agenda");
        count = gtk_statusbar_push(GTK_STATUSBAR(statusbar1), context_id, (gchar *) message);

}

gboolean
on_window1_destroy_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gtk_main_quit();
  return FALSE;
}


void
on_window1_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{
    gtk_main_quit();

}


// Buscar
void
on_button2_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
    gchar *buscar;
    gchar *texto[1][3];
    int indx=0, total_filas=0;

    statusbar_message("Buscando...");

    buscar = gtk_entry_get_text(GTK_ENTRY(entry1));

    total_filas = cuenta_tuplas();

    for(indx=0;indx<total_filas;indx++) {
        gtk_clist_get_text((GtkCList *)clist1,indx,0,&texto[0][0]);
        gtk_clist_get_text((GtkCList *)clist1,indx,1,&texto[0][1]);
	gtk_clist_get_text((GtkCList *)clist1,indx,2,&texto[0][2]);
	if(strstr(texto[0][0],buscar) || strstr(texto[0][1],buscar) || strstr(texto[0][2],buscar)) {
	    gtk_clist_select_row((GtkCList *)clist1,indx,0);
	    statusbar_message("Encontrado!");
	    break;
	} else {
	    statusbar_message("NO Encontrado!");
	}
    }
    ultima_pos=indx+1;
    return;
}

// Siguiente
void
on_button1_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
    gchar *buscar;
    gchar *texto[1][3];
    int indx, total_filas;
    
    statusbar_message("Buscando siguiente");

    buscar = gtk_entry_get_text(GTK_ENTRY(entry1));

    total_filas = cuenta_tuplas();

    for(indx=ultima_pos;indx<total_filas;indx++) {
        gtk_clist_get_text((GtkCList *)clist1,indx,0,&texto[0][0]);
        gtk_clist_get_text((GtkCList *)clist1,indx,1,&texto[0][1]);
        gtk_clist_get_text((GtkCList *)clist1,indx,2,&texto[0][2]);
        if(strstr(texto[0][0],buscar) || strstr(texto[0][1],buscar) || strstr(texto[0][2],buscar)) {
            gtk_clist_select_row((GtkCList *)clist1,indx,0);
            statusbar_message("Encontrado!");
            break;
        } else {
            statusbar_message("NO Encontrado!");
	}
    }
    ultima_pos=indx+1;
    return;
}

// Aadir nuevo registro
void
on_button4_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
    gchar *new_nombre;
    gchar *new_telefono;
    gchar *new_mail;
    gchar new_insert[1024];

    statusbar_message("Aadiendo nueva entrada...");
    new_nombre = gtk_entry_get_text(GTK_ENTRY(entry2));
    new_telefono = gtk_entry_get_text(GTK_ENTRY(entry3));
    new_mail = gtk_entry_get_text(GTK_ENTRY(entry4));

    sprintf(new_insert,"insert into agenda values (\'%s\',\'%s\',\'%s\');",new_nombre,new_telefono,new_mail);
    make_update(new_insert);
    statusbar_message("Datos introducidos correctamente");
    gtk_label_set_text((GtkLabel *)label8,"Resultado: OK, sin problemas");
}

// eliminar configuracion
void
on_button6_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{

}

// guardar configuracion
void
on_button5_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
    FILE *config;
    gchar linea[2048];
    gchar *nombre_conf;
    gchar *host_conf;
    gchar *puerto_conf;
    gchar *dbname_conf;
    gchar *user_conf;
    gchar *pass_conf;
    char *elhome=NULL;
    static char *rcconfig="/.gtkagendarc";

    
    elhome=alloca(strlen(getenv("HOME"))+14);
    strcpy(elhome,getenv("HOME"));
    strcat(elhome,rcconfig);

    nombre_conf =  gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo1)->entry));
    host_conf = gtk_entry_get_text(GTK_ENTRY(entry6));
    puerto_conf = gtk_entry_get_text(GTK_ENTRY(entry7));
    dbname_conf = gtk_entry_get_text(GTK_ENTRY(entry8));
    user_conf = gtk_entry_get_text(GTK_ENTRY(entry9));
    pass_conf = gtk_entry_get_text(GTK_ENTRY(entry10));

    /*
    if(nombre_conf==NULL || !host_conf || !puerto_conf || !dbname_conf || !user_conf || !pass_conf) {
	statusbar_message(_("Debe introducir todos los datos"));
	return;
    } */
    
    // encrypted = crypt(pass_conf,"$1$1a3a5b7c");

    sprintf(linea,"%s:%s:%s:%s:%s:%s\n",nombre_conf,host_conf,puerto_conf,dbname_conf,user_conf,pass_conf);

    config = fopen(elhome,"a");
    if(config==NULL) 
	g_print("Error en guardar config %s",elhome);
    fprintf(config,"%s",linea);
    fclose(config);
    statusbar_message(_("Configuracin guardada correctamente"));
    conexion_ok=1;
}


// Pasamos la columna seleccionada a las 
// entradas de texto por si queremos editarlas
void
on_clist1_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
    gchar *texto[1][3];

    /* pillamos el la fila que acaba de ser seleccionada */
    gtk_clist_get_text((GtkCList *)clist1,row,0,&texto[0][0]);
    gtk_clist_get_text((GtkCList *)clist1,row,1,&texto[0][1]);
    gtk_clist_get_text((GtkCList *)clist1,row,2,&texto[0][2]);

    /* la ponemos en las entradas de la pestaa nuevo */
    gtk_entry_set_text(GTK_ENTRY(entry2),texto[0][0]);
    gtk_entry_set_text(GTK_ENTRY(entry3),texto[0][1]);
    gtk_entry_set_text(GTK_ENTRY(entry4),texto[0][2]);

    /* y el email en la entrada de la pestaa email */
    gtk_entry_set_text(GTK_ENTRY(entry14),texto[0][2]);

    fila_seleccionada=row;
}

// eliminar una fila
void
on_button7_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
    gchar fila[1024];
    gchar *texto[1][3];
    
    if(fila_seleccionada>-1) {
	statusbar_message("Eliminando entrada...");
	gtk_clist_get_text((GtkCList *)clist1,fila_seleccionada,0,&texto[0][0]);
	sprintf(fila,"delete from agenda where nombre=\'%s\';",texto[0][0]);
	if(make_update(fila)==0) {
		gtk_clist_remove((GtkCList *)clist1,fila_seleccionada);
		statusbar_message("Eliminado!");
		fila_seleccionada=-1;
	}
    } else {
	statusbar_message("No hay filas seleccionadas!");
    }
}


void
on_button3_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_main_quit();
}

void
on_combo_entry_activate		(GtkWidget *	widget,
				gpointer	user_data)
{
    gchar *seleccion;
    FILE *config;
    gchar line_conf[1024];
    gchar *linea;
    gchar *conf_host;
    gchar *conf_port;
    gchar *conf_dbname;
    gchar *conf_user;
    gchar *conf_pass;
    char *elhome=NULL;
    static char *rcconfig="/.gtkagendarc";

    elhome=alloca(strlen(getenv("HOME"))+14);
    strcpy(elhome,getenv("HOME"));
    strcat(elhome,rcconfig);
      
    seleccion = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo1)->entry));
    if((config = fopen(elhome,"r"))!=NULL) {
    
    while(fgets(line_conf,254,config)!=NULL) {
        if(strstr("#",line_conf))
            break;
        linea=strtok(line_conf,":");
	if(!strcmp(linea,seleccion)) {
	    conf_host=strtok(NULL,":");
	    conf_port=strtok(NULL,":");
	    conf_dbname=strtok(NULL,":");
	    conf_user=strtok(NULL,":");
	    conf_pass=strtok(NULL,"\n");
            gtk_entry_set_text(GTK_ENTRY(entry6),conf_host);
            gtk_entry_set_text(GTK_ENTRY(entry7),conf_port);
            gtk_entry_set_text(GTK_ENTRY(entry8),conf_dbname);
            gtk_entry_set_text(GTK_ENTRY(entry9),conf_user);
            gtk_entry_set_text(GTK_ENTRY(entry10),conf_pass);
	}
    }
    fclose(config);
    statusbar_message(seleccion);
    }
}

void on_notepad1_switch_page (GtkWidget *widget, GtkNotebookPage *page, gint page_num) {
    gtk_clist_clear((GtkCList *)clist1);
    if(page_num==0 && conexion_ok==1)
	make_query("declare mycursor cursor for select nombre,telefono,mail from agenda order by nombre asc;");
}

// enviar mensaje
void
on_button10_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
    gchar mensaje[32000];
    gchar *de;
    gchar *para;

    de = gtk_entry_get_text(GTK_ENTRY(entry11));
    para = gtk_entry_get_text(GTK_ENTRY(entry14));

    if(!strcmp(de,"") || !strcmp(para,"")) {
	return;
    }
    
    sprintf(mensaje,"From: %s\r\nTo: %s\r\nSubject: %s\r\nX-Mailer: Gtk-Agenda (http://pbrufal.kleenux.org)\r\n\r\n%s\r\n",
	    gtk_entry_get_text(GTK_ENTRY(entry11)),
	    gtk_entry_get_text(GTK_ENTRY(entry14)),
	    gtk_entry_get_text(GTK_ENTRY(entry13)),
	    gtk_editable_get_chars(GTK_EDITABLE(text1),0,-1));
    if(smtp_connect("localhost",25)<0) {
	statusbar_message("Error en la conexin con el servidor");
	return;
    }
    statusbar_message("Enviando mensaje...");
    if(smtp_sendmail(para,de,mensaje)<0) {
	statusbar_message("Error enviando el mensaje");
	smtp_disconnect();
	return;
    }
    smtp_disconnect();
    statusbar_message("Mensaje enviado correctamente");
}

// cancelar mensaje
void
on_button11_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
    //gtk_entry_set_text(GTK_ENTRY(entry11),"");
    gtk_entry_set_text(GTK_ENTRY(entry14),"");
    gtk_entry_set_text(GTK_ENTRY(entry13),"");
}
