#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"
#include "psql_conn.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

void leer_configuracion(void) {
    FILE *config;
    FILE *firma;
    gchar line_conf[1024];
    char *linea=NULL;
    GList *lista_config=NULL;
    char *lafirma;
    char *elhome;
    char *email;
    static char *rcconfig="/.gtkagendarc";
    static char *signature="/.signature";

    elhome=alloca(strlen(getenv("HOME"))+14);
    lafirma=alloca(strlen(getenv("HOME"))+12);
    strcpy(elhome,getenv("HOME"));
    strcpy(lafirma,getenv("HOME"));
    strcat(elhome,rcconfig);
    strcat(lafirma,signature);
  
    gtk_text_freeze(GTK_TEXT(text1));
    firma = fopen(lafirma,"r");
    if(firma) {
	char buffer[1024];
	int nchars;

	while (1) {
	    nchars = fread(buffer, 1, 1024, firma);
	    gtk_text_insert (GTK_TEXT(text1), gdk_font_load ("-misc-fixed-medium-r-*-*-*-140-*-*-*-*-*-*"), NULL, NULL, buffer, nchars);
	    if (nchars < 1024)
		break;
	}
	fclose (firma);
    }
    gtk_text_thaw(GTK_TEXT(text1));

    if(getenv("EMAIL")!=NULL) {
	email=alloca(strlen(getenv("EMAIL"))+50);
	strcpy(email,getenv("EMAIL"));
	gtk_entry_set_text(GTK_ENTRY(entry11),email);
    }

    config = fopen(elhome,"r");
    if(config==NULL) {
	gtk_notebook_set_page((GtkNotebook *)notebook1,2);
	return;
    }
    while(fgets(line_conf,1023,config)!=NULL) {
	if(strstr("#",line_conf) || line_conf[0]=='\n')
	    continue;
	linea=strtok(line_conf,":");
	lista_config = g_list_append(lista_config,strdup(linea));
    }
    gtk_combo_set_popdown_strings(GTK_COMBO(combo1),lista_config);
    g_list_free(lista_config);
    fclose(config);

    gtk_clist_clear((GtkCList *)clist1);
    make_query("declare mycursor cursor for select nombre,telefono,mail from agenda order by nombre asc;");
    conexion_ok=1;
    return;
}

int
main (int argc, char *argv[])
{
  GtkWidget *window1;

#ifdef ENABLE_NLS
  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain (PACKAGE);
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
  add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");

  window1 = create_window1 ();
  gtk_widget_show (window1);

  leer_configuracion();

  gtk_main ();
  return 0;
}

