#include <stdio.h>
#include <postgresql/libpq-fe.h>
#include <string.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include "interface.h"
#include "psql_conn.h"

void exit_nicely(PGconn *conn) {
    PQfinish(conn);
//    exit(1);
}

int make_query(const char *cons) {
    char *pghost, *pgport, *pguser, *pgpasswd, *dbName;
    PGconn     *conn;
    PGresult   *res;
    char *select_row[1][3];
    int tuplas=0,i=0;
    char *temp=NULL;
    
    pghost = gtk_entry_get_text(GTK_ENTRY(entry6));
    pgport = gtk_entry_get_text(GTK_ENTRY(entry7));
    dbName = gtk_entry_get_text(GTK_ENTRY(entry8));
    pguser = gtk_entry_get_text(GTK_ENTRY(entry9));
    pgpasswd = gtk_entry_get_text(GTK_ENTRY(entry10));

    conn = PQsetdbLogin(pghost, pgport, NULL, NULL, dbName, pguser, pgpasswd);
    if (PQstatus(conn) == CONNECTION_BAD) {
	sprintf(temp,"Fall la conexin a '%s'",dbName);
	gtk_label_set_text((GtkLabel *)label8,temp);
        fprintf(stderr, "%s", PQerrorMessage(conn));
        exit_nicely(conn);
	return(1);
    }
    res = PQexec(conn, "BEGIN");
    if (!res || PQresultStatus(res) != PGRES_COMMAND_OK) {
	gtk_label_set_text((GtkLabel *)label8,"Fallo en el comando BEGIN");
        PQclear(res);
        exit_nicely(conn);
	return(1);
    }
    PQclear(res);
    res = PQexec(conn, cons);
    if (!res || PQresultStatus(res) != PGRES_COMMAND_OK) {
	gtk_label_set_text((GtkLabel *)label8,"Fallo en el comando DECLARE CURSOR");
        fprintf(stderr, "%s", PQerrorMessage(conn));
        PQclear(res);
        exit_nicely(conn);
	return(1);
    }
    PQclear(res);
    res = PQexec(conn, "FETCH ALL in mycursor");
    if (!res || PQresultStatus(res) != PGRES_TUPLES_OK) {
	gtk_label_set_text((GtkLabel *)label8,"FETCH ALL fall");
        fprintf(stderr, "FETCH ALL command didn't return tuples properly\n");
        PQclear(res);
        exit_nicely(conn);
	return(1);
    }
    tuplas = PQntuples(res);
    for(i=0;i<tuplas;i++) {
	select_row[0][0] = PQgetvalue(res, i, 0);
    	select_row[0][1] = PQgetvalue(res, i, 1);
    	select_row[0][2] = PQgetvalue(res, i, 2);
	gtk_clist_append((GtkCList *)clist1,select_row[0]);
    }
    PQclear(res);
    res = PQexec(conn, "CLOSE mycursor");
    PQclear(res);
    res = PQexec(conn, "COMMIT");
    PQclear(res); 
    PQfinish(conn);
    return(0);
}

int make_update(const char *cons) {
    char *pghost, *pgport, *pguser, *pgpasswd, *dbName;
    PGconn     *conn;
    PGresult   *res;
    char *temp=NULL;

    pghost = gtk_entry_get_text(GTK_ENTRY(entry6));
    pgport = gtk_entry_get_text(GTK_ENTRY(entry7));
    dbName = gtk_entry_get_text(GTK_ENTRY(entry8));
    pguser = gtk_entry_get_text(GTK_ENTRY(entry9));
    pgpasswd = gtk_entry_get_text(GTK_ENTRY(entry10));

    conn = PQsetdbLogin(pghost, pgport, NULL, NULL, dbName, pguser, pgpasswd);

    if (PQstatus(conn) == CONNECTION_BAD)
    {
	sprintf(temp,"Fall la conexin a '%s'",dbName);
	gtk_label_set_text((GtkLabel *)label8,temp);
        fprintf(stderr, "Connection to database '%s' failed.\n", dbName);
        fprintf(stderr, "%s", PQerrorMessage(conn));
        exit_nicely(conn);
    }

    res = PQexec(conn, "BEGIN");
    if (PQresultStatus(res) != PGRES_COMMAND_OK) {
	gtk_label_set_text((GtkLabel *)label8,"El comando BEGIN fall");
    	PQclear(res);
    	exit_nicely(conn);
    }

    PQclear(res); 
    res = PQexec(conn, cons);

    if (PQresultStatus(res) != PGRES_COMMAND_OK) {
    	fprintf(stderr, "%s", PQerrorMessage(conn));
    	return (-1);
   	}

    res = PQexec(conn, "COMMIT");

    PQfinish(conn);
    return 0;
}

int cuenta_tuplas(void) {
    char *pghost, *pgport, *pguser, *pgpasswd, *dbName;
    PGconn     *conn;
    PGresult   *res;
    int tuplas=0;
    char *temp=NULL;
   
    pghost = gtk_entry_get_text(GTK_ENTRY(entry6));
    pgport = gtk_entry_get_text(GTK_ENTRY(entry7));
    dbName = gtk_entry_get_text(GTK_ENTRY(entry8));
    pguser = gtk_entry_get_text(GTK_ENTRY(entry9));
    pgpasswd = gtk_entry_get_text(GTK_ENTRY(entry10));
       
    conn = PQsetdbLogin(pghost, pgport, NULL, NULL, dbName, pguser, pgpasswd);
    if (PQstatus(conn) == CONNECTION_BAD) {
	sprintf(temp,"Fall la conexin a '%s'",dbName);
	gtk_label_set_text((GtkLabel *)label8,temp);
        fprintf(stderr, "%s", PQerrorMessage(conn));
        exit_nicely(conn);
    }
    res = PQexec(conn, "BEGIN");
    if (!res || PQresultStatus(res) != PGRES_COMMAND_OK) {
	gtk_label_set_text((GtkLabel *)label8,"El comando BEGIN fall");
        PQclear(res);
        exit_nicely(conn);
    }
    PQclear(res);
    res = PQexec(conn, "declare mycursor cursor for select nombre from agenda;");
    if (!res || PQresultStatus(res) != PGRES_COMMAND_OK) {
	gtk_label_set_text((GtkLabel *)label8,"El comando DECLARE CURSOR fall");
        fprintf(stderr, "%s", PQerrorMessage(conn));
        PQclear(res);
        exit_nicely(conn);
    }
    PQclear(res);
    res = PQexec(conn, "FETCH ALL in mycursor");
    if (!res || PQresultStatus(res) != PGRES_TUPLES_OK) {
	gtk_label_set_text((GtkLabel *)label8,"El comando FETCH ALL fall");
        PQclear(res);
        exit_nicely(conn);
    }
    tuplas = PQntuples(res);
    PQclear(res);
    res = PQexec(conn, "CLOSE mycursor");
    PQclear(res);
    res = PQexec(conn, "COMMIT");
    PQclear(res);
    PQfinish(conn);
    return tuplas;
}

